/*
       	simple library for circular lists manipulation 
        Written by Anicka <anicka@anicka.net> in 2007,
	inspiration came from libucw.

        Can be used according to terms of GPL version 2.
*/

struct node {
	struct node* prev;
	struct node* next;
};

struct list {
	struct node head;
};

#define LIST_FOREACH(p,list) for(p=(void*)(list)->head.next; (struct node*)p!=&(list)->head; p=(void*)((struct node*) p)->next)
void list_init(struct list* l);
int list_is_empty(struct list* l);
void* list_first(struct list* l);
void* list_last(struct list* l);
void* list_prev(struct list* l, struct node* n);
void* list_next(struct list* l, struct node* n);
void list_add_first(struct list* l, struct node* new);
void list_add_last(struct list* l, struct node* new);
void list_add_after(struct node* orig, struct node* new);
void list_add_before(struct node* orig, struct node* new);
void list_del_node(struct node* n);
void* list_del_first(struct list* l);
void* list_del_last(struct list* l);
