/*
        brum - sort e-mail over IMAP utility    
        Written by Anicka <anicka@anicka.net> in 2008

        Can be used according to terms of GPL version 2.
*/

#include <stdio.h>
#include <stdlib.h>
#include <pcre.h>
#include <string.h>
#include <stdarg.h>
#include "lists.h"
#include "common.h"
#include "parseconf.h"

FILE* fconf;
struct list recipe_list;

void
show_recipe_list(struct list* rl)
{
	struct recipe* prec;
	struct rule* prul;

	LIST_FOREACH(prec,rl){
		puts("My rules:");
		LIST_FOREACH(prul,&prec->rules){
			printf("--type: %d, name: %s\n",prul->type,prul->name);
		}
		if (prec->mailbox)
			printf("My mailbox: %s\n",prec->mailbox);
		putchar('\n');
	}
}

struct recipe*
new_recipe(void)
{
	struct recipe* nr=xmalloc(sizeof(struct recipe));
	list_init(&nr->rules);
	nr->mailbox=NULL;

	return nr;
}

struct rule*
new_rule(int len)
{
	struct rule* nr=xmalloc(sizeof(struct rule)+len);

	return nr;
}

//TODO: do not require spaces 
void
parse_config_file(char* config)
{
	char line[BUFSIZE];
	struct recipe* nrecipe=NULL;
	int nl=0;

	if (!(fconf=fopen(config,"r")))
		die("Cannot open config file");

	list_init(&recipe_list);
	while (fgets(line,sizeof(line),fconf)){
		struct rule* nrule;
		int erroroffset;
       		const char* error;
		int len=strlen(line)-1;

		nl++;
		if (line[len]=='\n')
			line[len]=0;
		else
			len++;

		if (!line[0]){
			nrecipe=NULL;
			continue;
		}

		if (!nrecipe)
			list_add_last(&recipe_list,&(nrecipe=new_recipe())->car);
		switch (line[0]){
			case '*':
				if (line[1]!=' ')
					die("Syntax error on line %d: %s",nl,line);
				nrule=new_rule(len);
				nrule->type=REGEX;
				nrule->rule.r.compreg=pcre_compile(line+2,0,&error,&erroroffset,NULL);
				if (!nrule->rule.r.compreg)
					die("Regex compilation error on line %d: %s",nl,line+2);
					
				strcpy(nrule->name,line+2);
				list_add_last(&nrecipe->rules,&nrule->car);	
			break;
			case '>':
				if (line[1]!=' ')
					die("Syntax error on line %d: %s",nl,line);
				 nrecipe->mailbox=xmalloc(len);
				 strcpy(nrecipe->mailbox,line+2);
			break;
			default:
				die("Unknown type of rule in config file on line %d: %c",nl,line[0]);
		}	
	}
}
